/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MISC_FILESYSTEM_H
#define MISC_FILESYSTEM_H

//#include "file.hpp"
#include <string>
#include <vector>

class File;

#ifdef __WIN32__
	#define SEPERATOR "\\"
#else
	#define SEPERATOR "/"
#endif

/**
 * Simple filesystem stuff. Quickly made because I find the M$ API crap. This
 * get's the job done, but doesn't win a beautycontest ;)
 */
class Filesystem
{
public:
	Filesystem();

	void ScanDir	(const std::string& directoryPath, bool recursive = false);
	static void CreateDir	(const std::string& dirName, bool deleteExisting = false);
	static void RemoveDir	(const std::string& dirName);

	const std::vector<File*>&	FileList		()						{ return m_fileList; }
	void 						ExtentionFilter	(const std::string& ext){ m_extention = ext; }

private:
	std::vector<File*>	m_fileList;
	std::string 		m_extention;
};

#endif
