/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef BACKUPHDDVD_UTILS_H
#define BACKUPHDDVD_UTILS_H

typedef unsigned char byte;

#include <string>
#include <vector>
#include <stdint.h>

/**
 *
 */
class Utils
{
public:
	static void			ToHexString			(unsigned char const* 		array,
											 std::string& 				hexString,
											 const unsigned short		length);
	static std::string	ToHexString			(uint8_t const* 			array, 
											 const unsigned short 		length);
	static void 		HexStringToByteArray(const std::string&			hexString,
											 unsigned char* 			array);
	static void 		Xor					(unsigned char 				(&buffer)[16],
											 unsigned char const* 		chain);
	static void 		Trim				(std::string& 				str);
	static void 		Tokenize			(const std::string& 		str, 
											 std::vector<std::string>& 	tokens, 
											 const std::string& 		delimiters);
	static void 		AddSlash			(std::string& 				path);
};

#endif
