/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ACA_DECRYPTER_H
#define ACA_DECRYPTER_H

#include "logger.hpp"
#include <string>

class ACADecrypter
{
public:
	ACADecrypter(Logger& oLog);

	void DecryptFile(const std::string& sourceFile, const std::string& destinationDir);

	void SetKeyDB		(const std::string& keyDBFilename);
	void SetDevice		(const std::string& device);
	void SetMountPoint	(const std::string& mountPoint);
	void SetWriteOutput	(bool				writeToDisk);

private:
	Logger&			m_oLog;
	std::string 	m_keyDBFilename;
	std::string 	m_device;
	std::string 	m_mountPoint;
	bool			m_writeToDisk;
};

#endif
