/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __EVOB_DECRYPTER_H__
#define __EVOB_DECRYPTER_H__

#include "aacs.hpp"
#include "logger.hpp"
//#include "file.hpp"
#include <string>

const std::string version = "v0.5";

class EVOBDecrypter
{
public:
	EVOBDecrypter(Logger& oLog);

	bool StartDecrypting	(bool 				useDriveAuthentication);
	void DecryptFile		(std::string 		filename,
							 AACS*				Disc);

	void SetDevice			(const std::string&	device);
	void SetMountPoint		(const std::string& mountPoint);
	void SetDestinationPath	(const std::string& destinationPath);
	void SetFileName		(const std::string& filename);
	void SetKeyDB			(const std::string& keyDBFilename);
	void SetWriteOutput		(bool 				writeOutput);
	void SetDumpOutput		(bool 				dumpOutput);
	void SetChunkSize		(unsigned long		chunkSize);

private:
	Logger&			m_oLog;
	std::string		m_device;
	std::string 	m_mountPoint;
	std::string 	m_destinationPath;
	std::string		m_filename;
	std::string 	m_keyDBFilename;
	bool			m_writeOutput;
	bool			m_dumpOutput;
	unsigned long	m_chunkSize;
};

#endif
