#include "fusexx.hpp"
#include "aacs.hpp"
#include <string>
#include <dirent.h>
#include <map>

class HdDvdFs : public fusexx::fuse<HdDvdFs> {
public:
	HdDvdFs (std::string dev); // Constructor

	void set_mountpoint(std::string path);

	// Overload the fuse methods
	static int getattr	(const char *, struct stat *);
	static int readdir 	(const char *, void *, fuse_fill_dir_t, off_t, struct fuse_file_info *);
	static int open 	(const char *, struct fuse_file_info *);
	static int read 	(const char *, char *, size_t, off_t, struct fuse_file_info *);
	static int release 	(const char *, struct fuse_file_info *);
	void unmount();

private:
	// Private variables
	std::string m_Device;			// Dvd device (/dev/scd0)
	std::string m_UdfMountPoint;	// Where dvd udf fs is mounted (/mnt/.hddvd)
	std::string m_MountPoint;		// Where hddvdfs fuse is mounted (/mnt/hddvd)
	int 		m_refcnt;			// How many files using mount
	bool 		m_mounted;			// Is our udf mounted?
	AACS *		m_disc;
	DIR *		m_dir;
	static std::map<std::string, struct stat> fileMap;

	int 	addref();
	void 	delref();
	int 	try_unmount();
};
