/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MISC_FILESYSTEM_FILE_H
#define MISC_FILESYSTEM_FILE_H

#include <string>
#include <stdint.h>

class File
{
public:
	File(std::string strFilename);
	File(std::string strPath, std::string strFilename, uint64_t ui64FileSize = 0LL, bool bIsDirectory = false);

	unsigned char*	LoadFileIntoMemory();
	void 			CalcFileSize();

	std::string 	Path() 			{ return m_strPath; }
	std::string 	FileName()		{ return m_strFileName; }
	uint64_t 		FileSize()		{ if (0LL == m_ui64FileSize) CalcFileSize(); return m_ui64FileSize; }
	bool 			IsDirectory()	{ return m_bIsDirectory; }
	
private:
	std::string 	m_strPath;
	std::string 	m_strFileName;
	uint64_t		m_ui64FileSize;
	bool 			m_bIsDirectory;
};

#endif
